package demo.areacharts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.StackedAreaRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedAreaChartDemo1 extends JPanel {

  public StackedAreaChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedAreaChart("Stacked Area Chart", "Category", "Value",
                                                        dataset, ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;

    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    StackedAreaRender render = (StackedAreaRender) plot.getRender() ;
    render.setBackgroundPaint(Color.lightGray) ;
    render.setBaseValue(5) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("S1") ;
    dataset.addRowKey("S2") ;
    dataset.addRowKey("S3") ;
    for (int i = 1 ; i <= 8 ; i++) {
      dataset.addColKey("C" + i) ;
    }

    double[][] values = { {1.0D, 2D, 3D, 4D, 5D, 6D, 7D, 8D}, {6D, 3D, 4D, 3D, 9D, 7D, 2D, 3D},
                        {1.0D, 7D, 6D, 7D, 4D, 5D, 3D, 1.0D}
    } ;

    for (int i = 0 ; i < values.length ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j < values[i].length ; j++) {
        dataset.addData(i, new NumberChartData(values[i][j])) ;
      }
    }

    return dataset ;
  }

}
