package demo.barcharts.category ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar3DRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BarChart3DDemo3 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public BarChart3DDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar3DChart(
      "3D Bar Chart Demo 3", "Category", "Value", dataset, orientation, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlineVisible(false) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setTickLabelAngle( -0.39269908169872414D) ;

    Bar3DRender render = (Bar3DRender) plot.getRender() ;
    render.setItemMargin(0.20000000000000001D) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Category 1") ;
    dataset.addRowKey("Category 2") ;

    for (int i = 1 ; i <= 3 ; i++) {
      dataset.addColKey("Series " + i) ;
    }

    double data[][] = { {25D, 19D, 41D}, {34D, 29D, 33D}
    } ;
    dataset.addRowData(2) ;

    for (int i = 0 ; i < 2 ; i++) {
      for (int j = 0 ; j < 3 ; j++) {
        dataset.addData(i, new NumberChartData(data[i][j])) ;
      }
    }

    return dataset ;
  }

}
