package demo.barcharts.xy ;

import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.StackedNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.StackedBarRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedBarChartDemo4 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public StackedBarChartDemo4() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedBarChart("Stacked Bar Chart Demo 4", null,
                                                       "Value", dataset, orientation, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    StackedNumberValueAxis numberaxis = (StackedNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    CategoryAxis xAxis2 = new CategoryAxis("Product / Month", createDataset2()) ;
    xAxis2.setAxisLineVisible(false) ;
    xAxis2.setTickMarkVisible(false) ;
    plot.setCategoryAxis(1, xAxis2) ;
    plot.setCategoryAxisLocation(1, AxisLocation.BOTTOM_OR_RIGHT) ;

    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, new Color(34, 34, 255), 0.0F, 0.0F,
                                                    new Color(136, 136, 255)) ;
    render.setColumnItemFillPaint(0, gradientpaint) ;
    render.setColumnItemFillPaint(4, gradientpaint) ;
    render.setColumnItemFillPaint(8, gradientpaint) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, new Color(34, 255, 34), 0.0F, 0.0F,
                                                     new Color(136, 255, 136)) ;
    render.setColumnItemFillPaint(1, gradientpaint1) ;
    render.setColumnItemFillPaint(5, gradientpaint1) ;
    render.setColumnItemFillPaint(9, gradientpaint1) ;
    GradientPaint gradientpaint2 = new GradientPaint(0.0F, 0.0F, new Color(255, 34, 34), 0.0F, 0.0F,
                                                     new Color(255, 136, 136)) ;
    render.setColumnItemFillPaint(2, gradientpaint2) ;
    render.setColumnItemFillPaint(6, gradientpaint2) ;
    render.setColumnItemFillPaint(10, gradientpaint2) ;
    GradientPaint gradientpaint3 = new GradientPaint(0.0F, 0.0F, new Color(255, 255, 34), 0.0F,
                                                     0.0F, new Color(255, 255, 136)) ;
    render.setColumnItemFillPaint(3, gradientpaint3) ;
    render.setColumnItemFillPaint(7, gradientpaint3) ;
    render.setColumnItemFillPaint(11, gradientpaint3) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("US") ;
    dataset.addColKey("Europe") ;
    dataset.addColKey("Asia") ;
    dataset.addColKey("Middle East") ;

    for (int i = 1 ; i < 10 ; i++) {
      dataset.addRowKey("Product " + (i % 3 == 0 ? 3 : i % 3)) ;
    }

    double dataArr[][] = { {20.300000000000001D, 19.399999999999999D, 16.5D, 13.199999999999999D},
                         {23.300000000000001D, 12.699999999999999D, 15.4D, 23.800000000000001D},
                         {11.9D, 15.300000000000001D, 23.899999999999999D, 13.199999999999999D},
                         {27.199999999999999D, 10.9D, 15.9D, 14.4D}, {16.199999999999999D,
                         17.899999999999999D, 21D, 23.399999999999999D}, {31D, 14.4D, 19D, 15.5D},
                         {19.699999999999999D, 18.399999999999999D, 16.100000000000001D,
                         13.699999999999999D}, {28.699999999999999D, 12.6D, 11.1D,
                         19.300000000000001D}, {22.699999999999999D, 25.300000000000001D, 10.1D,
                         10.1D}
    } ;

    dataset.addRowData(dataArr.length) ;
    for (int i = 0 ; i < dataArr.length ; i++) {
      for (int j = 0 ; j < dataArr[i].length ; j++) {
        dataset.addData(i, new NumberChartData(dataArr[i][j])) ;
      }
    }

    return dataset ;
  }

  private IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    String[] rowKeys = {"", "Jan 04", "", "", "Feb 04", "", "", "Mar 04", ""} ;

    for (int i = 0 ; i < rowKeys.length ; i++) {
      dataset.addRowKey(rowKeys[i]) ;
    }
    dataset.addRowData(rowKeys.length) ;

    return dataset ;
  }

}
