package demo.barcharts.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXNumberYBaseValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXNumberYBaseChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYBarChartDemo4 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public XYBarChartDemo4() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "XYBarChartDemo4", "X", "Y", dataset, orientation, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    IntervalXNumberYBaseValueAxis domainAxis = (IntervalXNumberYBaseValueAxis) xyplot.getDomainAxis() ;
    domainAxis.setAxisRangeIncludeZero(false) ;
    domainAxis.setTickUnit(new LongTickUnit()) ;

    IntervalXNumberYBaseValueAxis valueAxis = (IntervalXNumberYBaseValueAxis) xyplot.getValueAxis() ;
    valueAxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowData() ;

    final double leftOffset = 0.5D ;
    final double rightOffset = 0.90000000000000002D - leftOffset ;

    dataset.addData(0, new IntervalXNumberYBaseChartData(1.0D - leftOffset, 1.0D + rightOffset, 5D)) ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(2D - leftOffset,
                                                         2D + rightOffset, 70.799999999999997D)) ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(3D - leftOffset,
                                                         3D + rightOffset, 48.299999999999997D)) ;
    return dataset ;
  }

}
