package demo.barcharts.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYBarChartDemo6 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public XYBarChartDemo6() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createIntervalXYBar2DChart(
      "XYBarChartDemo6", "X", "Y", dataset, orientation, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) plot.getValueAxis() ;
    valueAxis.setAxisRangeIncludeZero(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;

    dataset.addRowData() ;

    dataset.addData(0,
                    new IntervalXYNumberChartData(0.90000000000000002D, 1.1000000000000001D,
                                                  0.90000000000000002D, 1.1000000000000001D)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(1.8D, 2.2000000000000002D, 1.8D,
                                                  2.2000000000000002D)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(2.7000000000000002D, 3.2999999999999998D,
                                                  2.7000000000000002D, 3.2999999999999998D)) ;
    dataset.addData(0,
                    new IntervalXYNumberChartData(3.6000000000000001D, 4.4000000000000004D,
                                                  3.6000000000000001D, 4.4000000000000004D)) ;

    return dataset ;
  }

}
