package demo.dataset ;

import com.ijchart.xychart.constant.SortType ;
import com.ijchart.xychart.data.IChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.AbstractDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.event.DatasetChangeEvent ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SampleXYDataset extends AbstractDataset implements IMatrixDataset {
  private double translate ;

  public SampleXYDataset() {
    translate = 0.0D ;
  }

  public double getTranslate() {
    return translate ;
  }

  public void setTranslate(double d) {
    translate = d ;
    notifyListeners(new DatasetChangeEvent(this, this)) ;
  }

  public boolean isThisDataType(Class c) {
    return true ;
  }

  public int getRowCount() {
    return 2 ;
  }

  public Object getRowKey(int index) {
    if (index == 0) {
      return "y = cosine(x)" ;
    }
    if (index == 1) {
      return "y = 2*sine(x)" ;
    } else {
      return "Error" ;
    }
  }

  public int getColumnCount() {
    return 200 ;
  }

  public int getColumnCount(int rowIdx) {
    return 200 ;
  }

  public Object getColKey(int index) {
    return null ;
  }

  public IChartData getData(int rowIndex, int colIndex) {
    double x = -10D + translate + (double) colIndex / 10D ;
    double y = 0 ;
    if (rowIndex == 0) {
      y = Math.cos( -10D + translate + (double) colIndex / 10D) ;
    } else {
      y = 2D * Math.sin( -10D + translate + (double) colIndex / 10D) ;
    }

    return new XYNumberChartData(x, y) ;
  }

  public boolean isEmpty() {
    return false ;
  }

  public void sortRowData(int rowIndex, SortType sortType) {
  }
}
