package demo.linecharts ;

import java.awt.Font ;
import java.awt.GridLayout ;
import java.io.BufferedReader ;
import java.io.FileReader ;
import java.net.URL ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.XYTextAnnotation ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.title.TextTitle ;
import demo.DemosTree ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class AnnotationDemo1 extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public AnnotationDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "Growth Charts: United States", "Age in Months", "Weight (kg)",
      dataset, vertical, true, true, false, false) ;

    TextTitle title = (TextTitle) chart.getTitle() ;
    title.setTextFont(new Font("SansSerif", 1, 14)) ;
    TextTitle title1 = new TextTitle("Weight-for-age percentiles: boys, birth to 36 months",
                                     new Font("SansSerif", Font.BOLD, 11)) ;
    chart.addSubtitle(title1) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.getDomainAxis().setUpperMargin(0.02D) ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYTextAnnotation annotation1 = new XYTextAnnotation("3rd", 36.5D, 11.76D) ;
    XYTextAnnotation annotation2 = new XYTextAnnotation("5th", 36.5D, 12.039999999999999D) ;
    XYTextAnnotation annotation3 = new XYTextAnnotation("10th", 36.5D, 12.493D) ;
    XYTextAnnotation annotation4 = new XYTextAnnotation("25th", 36.5D, 13.313000000000001D) ;
    XYTextAnnotation annotation5 = new XYTextAnnotation("50th", 36.5D, 14.33D) ;
    XYTextAnnotation annotation6 = new XYTextAnnotation("75th", 36.5D, 15.478D) ;
    XYTextAnnotation annotation7 = new XYTextAnnotation("90th", 36.5D, 16.641999999999999D) ;
    XYTextAnnotation annotation8 = new XYTextAnnotation("95th", 36.5D, 17.408000000000001D) ;
    XYTextAnnotation annotation9 = new XYTextAnnotation("97th", 36.5D, 17.936D) ;

    render.addAnnotation(annotation1) ;
    render.addAnnotation(annotation2) ;
    render.addAnnotation(annotation3) ;
    render.addAnnotation(annotation4) ;
    render.addAnnotation(annotation5) ;
    render.addAnnotation(annotation6) ;
    render.addAnnotation(annotation7) ;
    render.addAnnotation(annotation8) ;
    render.addAnnotation(annotation9) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = null ;
    try {
      URL url = DemosTree.class.getResource("others/resource/wtageinf.txt") ;
      String filePath = url.getPath() ;
      BufferedReader reader = new BufferedReader(new FileReader(filePath)) ;
      String str = reader.readLine() ;
      str = reader.readLine() ;
      str = reader.readLine() ;
      str = reader.readLine() ;

      dataset = new DefaultMatrixDataset() ;
      dataset.addRowKey("P3") ;
      dataset.addRowKey("P5") ;
      dataset.addRowKey("P10") ;
      dataset.addRowKey("P25") ;
      dataset.addRowKey("P50") ;
      dataset.addRowKey("P75") ;
      dataset.addRowKey("P90") ;
      dataset.addRowKey("P95") ;
      dataset.addRowKey("P97") ;
      dataset.addRowData(9) ;

      while ((str = reader.readLine()) != null) {
        String[] arr = str.split("[ ]+") ;
        for (int i = 0 ; i < arr.length ; i++) {
          arr[i] = arr[i].trim() ;
        }

        int i = Integer.parseInt(arr[1]) ;
        if (i == 1) {
          float f = Float.parseFloat(arr[2]) ;
          dataset.addData(0, new XYNumberChartData(f, Float.parseFloat(arr[6]))) ;
          dataset.addData(1, new XYNumberChartData(f, Float.parseFloat(arr[7]))) ;
          dataset.addData(2, new XYNumberChartData(f, Float.parseFloat(arr[8]))) ;
          dataset.addData(3, new XYNumberChartData(f, Float.parseFloat(arr[9]))) ;
          dataset.addData(4, new XYNumberChartData(f, Float.parseFloat(arr[10]))) ;
          dataset.addData(5, new XYNumberChartData(f, Float.parseFloat(arr[11]))) ;
          dataset.addData(6, new XYNumberChartData(f, Float.parseFloat(arr[12]))) ;
          dataset.addData(7, new XYNumberChartData(f, Float.parseFloat(arr[13]))) ;
          dataset.addData(8, new XYNumberChartData(f, Float.parseFloat(arr[14]))) ;
        }
      }
    } catch (Exception ex) {
      ex.printStackTrace() ;
    }

    return dataset ;
  }

}
