package demo.miscellaneous ;

import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class AxisOffsetsDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public AxisOffsetsDemo1() {
    setLayout(new GridLayout(2, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = createChart("Axis Offsets: 0") ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    chartpanel.setMinimumDrawWidth(0) ;
    chartpanel.setMinimumDrawHeight(0) ;

    IJChart chart1 = createChart("Axis Offsets: 5") ;
    ChartPanel chartpanel1 = new ChartPanel(chart1) ;
    chartpanel1.setMinimumDrawWidth(0) ;
    chartpanel1.setMinimumDrawHeight(0) ;
    CategoryPlot categoryplot1 = (CategoryPlot) chart1.getPlot() ;
    categoryplot1.setAxisOffset(new RectangleInsets(5D, 5D, 5D, 5D)) ;
    ChartPanel chartpanel2 = new ChartPanel(chart1) ;

    add(chartpanel) ;
    add(chartpanel2) ;
  }

  private IJChart createChart(String title) {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart(title, "Category", "Value", dataset,
                                                          orientation, false, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setBaseItemDrawBorder(false) ;
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                    new Color(0, 0, 64)) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, Color.green, 0.0F, 0.0F,
                                                     new Color(0, 64, 0)) ;
    GradientPaint gradientpaint2 = new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     new Color(64, 0, 0)) ;
    render.setAutoSelectFillPaint(false) ;
    render.setColumnItemFillPaint(0, gradientpaint) ;
    render.setColumnItemFillPaint(1, gradientpaint1) ;
    render.setColumnItemFillPaint(2, gradientpaint2) ;

    return chart ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("S1") ;
    dataset.addColKey("S2") ;
    dataset.addRowKey("C1") ;
    dataset.addRowKey("C2") ;
    dataset.addRowKey("C3") ;
    dataset.addRowKey("C4") ;
    dataset.addRowKey("C5") ;
    dataset.addRowData(5) ;

    double[][] values = { {1.0D, 4D, 3D, 5D, 5D}, {5D, 7D, 6D, 8D, 4D}, {4D, 3D, 2D, 3D, 6D}
    } ;
    for (int i = 0 ; i < 5 ; i++) {
      for (int j = 0 ; j < 3 ; j++) {
        dataset.addData(i, new NumberChartData(values[j][i])) ;
      }
    }

    return dataset ;
  }

}
