package demo.miscellaneous;

import java.awt.BorderLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;
import java.util.Calendar ;

import javax.swing.JButton ;
import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MultipleDatasetDemo1 extends JPanel implements ActionListener {
  private DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

  private int datasetIndex ;

  public MultipleDatasetDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;

    JButton jbutton = new JButton("Add Dataset") ;
    jbutton.setActionCommand("ADD_DATASET") ;
    jbutton.addActionListener(this) ;
    JButton jbutton1 = new JButton("Remove Dataset") ;
    jbutton1.setActionCommand("REMOVE_DATASET") ;
    jbutton1.addActionListener(this) ;
    JPanel jpanel1 = new JPanel() ;
    jpanel1.add(jbutton) ;
    jpanel1.add(jbutton1) ;
    add(jpanel1, BorderLayout.SOUTH) ;
  }

  private void addPanel1() {
    addDatas("Series 1") ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Multiple Dataset Demo 1", "Time", "Value",
                                                   dataset, ChartOrientation.VERTICAL, true,
                                                   true, true, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setAxisOffset(new RectangleInsets(4D, 4D, 4D, 4D)) ;
    plot.getValueAxis().setAxisRangeIncludeZero(false) ;
    ((XYLineAndShapeRender) plot.getRender()).setBaseItemShapeVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  private void addDatas(String s) {
    dataset.addRowKey(s) ;
    dataset.addRowData() ;

    double d = 100D ;
    Calendar cal = Calendar.getInstance() ;
    cal.set(Calendar.HOUR_OF_DAY, 0) ;
    cal.set(Calendar.MINUTE, 0) ;
    cal.set(Calendar.SECOND, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    for (int i = 0 ; i < 50 ; i++) {
      dataset.addData(datasetIndex, new XYNumberChartData(cal.getTimeInMillis(), d)) ;
      cal.add(Calendar.DAY_OF_MONTH, 1) ;
      d *= 1.0D + Math.random() / 100D ;
    }

  }

  public void actionPerformed(ActionEvent actionevent) {
    if (actionevent.getActionCommand().equals("ADD_DATASET")) {
      if (datasetIndex < 20) {
        datasetIndex++ ;
        addDatas("S" + datasetIndex) ;
      }
    } else if (actionevent.getActionCommand().equals("REMOVE_DATASET") && datasetIndex >= 1) {
      dataset.deleteRow(datasetIndex) ;
      datasetIndex-- ;
    }

  }
}
