package demo.miscellaneous;

import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.axis.value.SymbolValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SymbolAxisDemo1 extends JPanel {

  public SymbolAxisDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("SymbolicAxis Demo 1", "Domain", "Range",
                                                   dataset, ChartOrientation.VERTICAL, true,
                                                   true, false, false) ;

    chart.getLegendTitle().setPosition(RectangleEdge.BOTTOM) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    String[] xSymbols = {"A", "B", "C", "D"} ;
    plot.getDomainAxis().setLowerMargin(0.05);
    plot.getDomainAxis().setUpperMargin(0.05);
    SymbolValueAxis xAxis = new SymbolValueAxis("Domain", (NumberValueAxis) plot.getDomainAxis(),
                                                xSymbols) ;


    String[] ySymbols = {"V", "X", "Y", "Z"} ;
    plot.getValueAxis().setLowerMargin(0.05);
    plot.getValueAxis().setUpperMargin(0.05);
    SymbolValueAxis yAxis = new SymbolValueAxis("Range", (NumberValueAxis) plot.getValueAxis(),
                                                ySymbols) ;
    yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    plot.setDomainAxis(xAxis) ;
    plot.setValueAxis(yAxis) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemLineVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  public static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData(2) ;

    dataset.addData(0, new XYNumberChartData(0.0D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(1.0D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 0.0D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 1.0D)) ;

    dataset.addData(1, new XYNumberChartData(0.0D, 1.0D)) ;
    dataset.addData(1, new XYNumberChartData(1.0D, 2D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 1.0D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 3D)) ;

    return dataset ;
  }

}
