package demo.miscellaneous.itemlabel;

import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.label.LabelGeneratorAdaptor ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.StackedBarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ItemLabelDemo5 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public ItemLabelDemo5() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createStackedBarChart("Item Label Demo 5", null, null,
                                                       dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    StackedBarRender render = (StackedBarRender) plot.getRender() ;
    render.setLabelGenerator(new LabelGenerator()) ;
    render.setBaseItemLabelVisible(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Western EU") ;
    dataset.addRowKey("Southern EU") ;
    dataset.addRowKey("Eastern EU") ;
    dataset.addRowKey("Scandinavia") ;
    dataset.addRowKey("Africa") ;
    dataset.addRowKey("Asia") ;

    dataset.addColKey("Germany") ;
    dataset.addColKey("France") ;
    dataset.addColKey("Great Britain") ;
    dataset.addColKey("Netherlands") ;
    dataset.addColKey("Belgium") ;
    dataset.addRowData(6) ;

    dataset.addData(0, new NumberChartData(52.829999999999998D)) ;
    dataset.addData(0, new NumberChartData(20.829999999999998D)) ;
    dataset.addData(0, new NumberChartData(10.83D)) ;
    dataset.addData(0, new NumberChartData(7.3300000000000001D)) ;
    dataset.addData(0, new NumberChartData(4.6600000000000001D)) ;

    dataset.addData(1, new NumberChartData(57.140000000000001D)) ;
    dataset.addData(1, new NumberChartData(14.279999999999999D)) ;
    dataset.addData(1, new NumberChartData(14.279999999999999D)) ;
    dataset.addData(1, new NumberChartData(14.279999999999999D)) ;

    dataset.addData(2, new NumberChartData(100D)) ;
    dataset.addData(3, new NumberChartData(66.659999999999997D)) ;
    dataset.addData(3, new NumberChartData(33.329999999999998D)) ;
    dataset.addData(4, new NumberChartData(0.0D)) ;
    dataset.addData(5, new NumberChartData(100D)) ;

    return dataset ;
  }

  String[][] labels = new String[][] { {"0", "0", "Germany"}, {"0", "1", "France"}, {"0", "2",
                      "Great Britain"}, {"0", "3", "Netherlands"}, {"0", "4", "Belgium"}, {"1", "0",
                      "Spain"}, {"1", "1", "Greece"}, {"1", "2", "Italy"}, {"1", "3", "Portugal"},
                      {"2", "0", "Czech Republic"}, {"3", "0", "Denmark"}, {"3", "1", "Finland"},
                      {"4", "0", ""}, {"5", "0", "Israel"}
  } ;

  class LabelGenerator extends LabelGeneratorAdaptor {
    public String generateLabel(IMatrixDataset dataset, int row, int column) {
      for (int i = 0 ; i < labels.length ; i++) {
        String[] arr = labels[i] ;
        if (arr[0].equals(String.valueOf(row)) && arr[1].equals(String.valueOf(column))) {
          return arr[2] ;
        }
      }

      return null ;
    }

  }
}
