package demo.miscellaneous.legends ;

import java.awt.BorderLayout ;
import java.awt.Font ;
import java.awt.geom.Rectangle2D ;
import java.util.List ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;
import com.ijchart.xychart.shape.LegendItemChartShape ;
import com.ijchart.xychart.shape.RectangleTextChartShape ;
import com.ijchart.xychart.title.LegendTitle ;
import com.ijchart.xychart.ui.RectangleEdge ;
import com.ijchart.xychart.util.TextUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LegendWrapperDemo1 extends JPanel {
  public LegendWrapperDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPieChart("Legend Wrapper Demo 1", dataset, true, true) ;

    LegendTitle legend = chart.getLegendTitle() ;
    legend.setPosition(RectangleEdge.RIGHT) ;

    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;

    MyPieRender render = new MyPieRender(dataset) ;
    render.setCircular(true) ;
    render.setBaseItemLabelVisible(true) ;
    render.setLabelInPie(false) ;
    plot.setRender(render) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;
    dataset.addColKey("One") ;
    dataset.addColKey("Two") ;
    dataset.addColKey("Three") ;
    dataset.addColKey("Four") ;
    dataset.addColKey("Five") ;
    dataset.addColKey("Six") ;
    dataset.addRowData() ;

    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(27.5D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(11D)) ;
    dataset.addData(0, new NumberChartData(19.399999999999999D)) ;

    return dataset ;
  }

  class MyPieRender extends PieRender {
    MyPieRender(SingleRowDataset dataset) {
      super(dataset) ;
    }

    public  List calculateLegendItemShapes() {
      List shapes = super.calculateLegendItemShapes() ;

      String text = "Source: http://www.ijchart.org" ;
      Rectangle2D rect = TextUtil.getStringNoWrapBounds(text, new Font("Serif", 0, 12)) ;
      rect.setRect(rect.getX(), rect.getY(), rect.getWidth() + 15, rect.getHeight()) ;

      RectangleTextChartShape textShape = new RectangleTextChartShape(rect, text) ;
      LegendItemChartShape legendShape = new LegendItemChartShape(textShape, null) ;
      shapes.add(legendShape) ;

      return shapes ;
    }
  }
}
