package demo.multipleaxischarts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.RenderDrawOrder ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class DualAxisDemo1 extends JPanel {

  public DualAxisDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IJChart createChart() {
    IJChart chart = ChartFactory.createCategoryBar2DChart("Dual Axis Chart", "Category", "Value",
                                                          createDataset1(),
                                                          ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setCategoryAxisLocation(AxisLocation.BOTTOM_OR_RIGHT) ;

    IMatrixDataset dataset2 = createDataset2() ;
    LineAndShapeRender shapeRender = new LineAndShapeRender(dataset2) ;
    plot.setRender(1, shapeRender) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setTickLabelAngle(IAngle.ANGLE_DOWN_45) ;
    categoryaxis.setTickLabelInsets(RectangleInsets.INSETS_ZERO) ;

    NumberValueAxis numberaxis = new NumberValueAxis("Secondary", dataset2) ;
    numberaxis.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    plot.setValueAxis(1, numberaxis) ;
    plot.setRenderDrawOrder(RenderDrawOrder.FORWARD) ;

    return chart ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    for (int i = 1 ; i <= 3 ; i++) {
      dataset.addColKey("S" + i) ;
    }
    for (int i = 1 ; i <= 8 ; i++) {
      dataset.addRowKey("Category" + i) ;
    }

    double[][] datas = { {1, 4, 3, 5, 5, 7, 7, 8}, {5, 7, 6, 8, 4, 4, 2, 1}, {4, 3, 2, 3, 6, 3, 4,
                       3}
    } ;

    for (int i = 0 ; i < datas[0].length ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j < datas.length ; j++) {
        dataset.addData(i, new NumberChartData(datas[j][i])) ;
      }
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("S4") ;

    for (int i = 1 ; i <= 8 ; i++) {
      dataset.addColKey("Category" + i) ;
    }

    dataset.addRowData() ;
    double[] datas = {15, 24, 31, 25, 56, 37, 77, 18} ;
    for (int i = 0 ; i < datas.length ; i++) {
      dataset.addData(0, new NumberChartData(datas[i])) ;
    }

    return dataset ;
  }

}
