package demo.multipleaxischarts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MultipleAxisDemo1 extends JPanel {
  public MultipleAxisDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset("Series 1", 100D, 200) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Multiple Axis Demo 1", "Time of Day",
                                                           "Primary Range Axis", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setRowItemShapeVisible(0, false) ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setTickLabelPaint(Color.RED) ;
    valueAxis.setAxisLabelPaint(Color.RED) ;

    IMatrixDataset dataset2 = createDataset("Series 2", 1000D, 170) ;
    XYNumberValueAxis valueAxis2 = new XYNumberValueAxis("Range Axis 2", dataset2,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis2.setAxisRangeIncludeZero(false) ;
    valueAxis2.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    valueAxis2.setTickLabelPaint(Color.blue) ;
    valueAxis2.setAxisLabelPaint(Color.blue) ;
    plot.setValueAxis(1, valueAxis2) ;
    plot.setValueAxisLocation(1, AxisLocation.BOTTOM_OR_LEFT) ;

    XYLineAndShapeRender render2 = new XYLineAndShapeRender(dataset2) ;
    render2.setRowItemShapeVisible(0, false) ;
    plot.setRender(1, render2) ;

    IMatrixDataset dataset3 = createDataset("Series 3", 10000D, 170) ;
    XYNumberValueAxis valueAxis3 = new XYNumberValueAxis("Range Axis 3", dataset3,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis3.setAxisRangeIncludeZero(false) ;
    valueAxis3.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    valueAxis3.setTickLabelPaint(Color.green) ;
    valueAxis3.setAxisLabelPaint(Color.green) ;
    plot.setValueAxis(2, valueAxis3) ;

    XYLineAndShapeRender render3 = new XYLineAndShapeRender(dataset3) ;
    render3.setRowItemShapeVisible(0, false) ;
    plot.setRender(2, render3) ;

    IMatrixDataset dataset4 = createDataset("Series 3", 25D, 200) ;
    XYNumberValueAxis valueAxis4 = new XYNumberValueAxis("Range Axis 4", dataset4,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis4.setAxisRangeIncludeZero(false) ;
    valueAxis4.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    valueAxis4.setTickLabelPaint(Color.yellow) ;
    valueAxis4.setAxisLabelPaint(Color.yellow) ;
    plot.setValueAxis(3, valueAxis4) ;

    XYLineAndShapeRender render4 = new XYLineAndShapeRender(dataset4) ;
    render4.setRowItemShapeVisible(0, false) ;
    plot.setRender(3, render4) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset(String s, double d, int i) {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey(s) ;
    dataset.addRowData() ;

    long now = System.currentTimeMillis() ;
    double d1 = d ;
    for (int j = 0 ; j < i ; j++) {
      dataset.addData(0, new XYNumberChartData(now, d1)) ;
      d1 *= 1.0D + (Math.random() - 0.495D) / 10D ;

      now += 60 * 1000 ;
    }

    return dataset ;
  }

}
