package demo.multipleaxischarts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.ui.RectangleInsets ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MultipleAxisDemo3 extends JPanel {
  public MultipleAxisDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset1("Series 1", 100D, 200) ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Multiple Axis Demo 3", "Time of Day",
                                                           "Primary Range Axis", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.setAxisOffset(new RectangleInsets(5D, 5D, 5D, 5D)) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setRowItemShapeVisible(0, false) ;

    IMatrixDataset dataset2 = createDataset1("Series 2", 1000D, 170) ;
    XYLineAndShapeRender render2 = new XYLineAndShapeRender(dataset2) ;
    render2.setRowItemShapeVisible(0, false) ;
    plot.setRender(1, render2) ;

    XYNumberValueAxis rangeAxis2 = new XYNumberValueAxis("Domain Axis 2", dataset2,
                                                         XYValueAxisType.XY_VALUE_AXIS_X) ;
    rangeAxis2.setAxisRangeIncludeZero(false) ;
    plot.setDomainAxis(1, rangeAxis2) ;
    plot.setDomainAxisLocation(1, AxisLocation.BOTTOM_OR_LEFT) ;

    IMatrixDataset dataset3 = createDataset2() ;
    NumberValueAxis rangeAxis3 = new NumberValueAxis("Domain Axis 3", dataset3) ;
    rangeAxis3.setAxisRangeIncludeZero(false) ;
    plot.setDomainAxis(2, rangeAxis3) ;
    plot.setDomainAxisLocation(2, AxisLocation.BOTTOM_OR_LEFT) ;

    XYNumberValueAxis valueAxis2 = new XYNumberValueAxis("Value Axis 2", dataset2,
                                                         XYValueAxisType.XY_VALUE_AXIS_Y) ;
    valueAxis2.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;
    plot.setValueAxis(1, valueAxis2) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1(String s, double d, int i) {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey(s) ;
    dataset.addRowData() ;

    long now = System.currentTimeMillis() ;
    double d1 = d ;
    for (int j = 0 ; j < i ; j++) {
      dataset.addData(0, new XYNumberChartData(now, d1)) ;
      d1 *= 1.0D + (Math.random() - 0.495D) / 10D ;

      now += 60 * 1000 ;
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowData() ;

    dataset.addData(0, new NumberChartData(0)) ;
    dataset.addData(0, new NumberChartData(1)) ;

    return dataset ;
  }
}
