package demo.others ;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PriceVolumeChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  /** A working calendar. */
  private static final Calendar CALENDAR = Calendar.getInstance() ;

  public PriceVolumeChartPanel1() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//   addPanel2() ;
//   addPanel3() ;
//   addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IJChart chart = ChartFactory.createPriceVolumeChart(
      "This is a very long title,it has many words and wrap automatically.", "Date",
      "Volume", "Price", createVolumeDataset(), createPriceDataset(), vertical, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IJChart chart = ChartFactory.createPriceVolumeChart(
      "This is a very long title,it has many words and wrap automatically.", "Date",
      "Volume", "Price", createVolumeDataset(), createPriceDataset(), horizontal, true, true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createPriceVolumeChart(
      "This is a very long title,it has many words and wrap automatically.", "Date",
      "Volume", "Price", createVolumeDataset(), createPriceDataset(), vertical, true, true) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.getValueAxis(0).setInverted(true) ;
    plot.getValueAxis(1).setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createPriceVolumeChart(
      "This is a very long title,it has many words and wrap automatically.", "Date",
      "Volume", "Price", createVolumeDataset(), createPriceDataset(), horizontal, true, true) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.getValueAxis(0).setInverted(true) ;
    plot.getValueAxis(1).setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createVolumeDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;
    volumeDataset.addRowKey("Volume") ;
    volumeDataset.addRowData() ;

    volumeDataset.addData(0, createIntervalData(createDate(2, 1, 2002), 41020D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 1, 2002), 45586D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 1, 2002), 81672D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 1, 2002), 81975D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 1, 2002), 79692D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 1, 2002), 53187D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 1, 2002), 87929D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 1, 2002), 107047D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 1, 2002), 86276D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 1, 2002), 79005D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 1, 2002), 80632D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 1, 2002), 88797D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 1, 2002), 57179D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 1, 2002), 36611D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 1, 2002), 57063D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 1, 2002), 101938D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 1, 2002), 87177D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 1, 2002), 39831D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 1, 2002), 67654D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 1, 2002), 81162D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(31, 1, 2002), 64923D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 2, 2002), 73481D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 2, 2002), 54723D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 2, 2002), 76708D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 2, 2002), 81281D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 2, 2002), 66553D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 2, 2002), 53592D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 2, 2002), 29410D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 2, 2002), 60345D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 2, 2002), 67339D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 2, 2002), 40057D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 2, 2002), 67865D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 2, 2002), 58628D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 2, 2002), 52109D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 2, 2002), 50195D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 2, 2002), 47806D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 2, 2002), 31711D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 2, 2002), 88328D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(27, 2, 2002), 95805D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 2, 2002), 84035D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 3, 2002), 113584D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 3, 2002), 71872D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 3, 2002), 83016D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 3, 2002), 62273D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 3, 2002), 138508D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 3, 2002), 139428D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 3, 2002), 80232D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 3, 2002), 75693D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 3, 2002), 104068D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 3, 2002), 72171D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 3, 2002), 117262D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 3, 2002), 66048D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 3, 2002), 87079D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 3, 2002), 116084D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 3, 2002), 113206D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 3, 2002), 68326D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 3, 2002), 34340D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 3, 2002), 104413D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(27, 3, 2002), 57277D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 3, 2002), 69936D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 4, 2002), 57282D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(2, 4, 2002), 74686D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 4, 2002), 108601D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 4, 2002), 123381D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 4, 2002), 106691D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 4, 2002), 118535D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 4, 2002), 85577D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 4, 2002), 75441D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 4, 2002), 88845D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 4, 2002), 137141D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 4, 2002), 72518D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 4, 2002), 122100D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 4, 2002), 136419D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 4, 2002), 141338D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 4, 2002), 80274D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 4, 2002), 40449D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 4, 2002), 72292D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 4, 2002), 110644D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 4, 2002), 145142D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 4, 2002), 139573D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 4, 2002), 51509D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 4, 2002), 105782D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 5, 2002), 170680D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(2, 5, 2002), 140800D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 5, 2002), 170411D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 5, 2002), 46172D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 5, 2002), 137251D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 5, 2002), 220626D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 5, 2002), 175902D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 5, 2002), 128807D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 5, 2002), 78208D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 5, 2002), 212048D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 5, 2002), 145643D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 5, 2002), 121520D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 5, 2002), 147820D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 5, 2002), 75969D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 5, 2002), 118970D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 5, 2002), 131013D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 5, 2002), 141100D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 5, 2002), 63606D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 5, 2002), 78687D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 5, 2002), 86743D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 5, 2002), 164376D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(31, 5, 2002), 150108D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 6, 2002), 132363D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 6, 2002), 144902D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 6, 2002), 123834D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 6, 2002), 125004D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 6, 2002), 165049D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 6, 2002), 88069D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 6, 2002), 114146D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 6, 2002), 149992D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 6, 2002), 191261D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 6, 2002), 207444D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 6, 2002), 117081D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 6, 2002), 135924D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 6, 2002), 179654D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 6, 2002), 260936D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 6, 2002), 140283D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 6, 2002), 199052D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 6, 2002), 191804D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 6, 2002), 384936D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(27, 6, 2002), 313065D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 6, 2002), 169963D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 7, 2002), 109906D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(2, 7, 2002), 140644D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 7, 2002), 150898D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 7, 2002), 181355D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 7, 2002), 155042D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 7, 2002), 204305D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 7, 2002), 300113D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 7, 2002), 338948D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 7, 2002), 281325D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 7, 2002), 256101D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 7, 2002), 348164D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 7, 2002), 242995D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 7, 2002), 200744D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 7, 2002), 181071D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 7, 2002), 163266D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 7, 2002), 188508D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 7, 2002), 308070D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 7, 2002), 230901D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 7, 2002), 162577D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 7, 2002), 216318D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 7, 2002), 280677D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(31, 7, 2002), 260236D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 8, 2002), 242803D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(2, 8, 2002), 298490D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 8, 2002), 182890D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 8, 2002), 232273D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 8, 2002), 253552D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 8, 2002), 165365D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 8, 2002), 160382D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 8, 2002), 118030D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 8, 2002), 208807D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 8, 2002), 231599D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 8, 2002), 343482D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 8, 2002), 186116D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 8, 2002), 96437D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 8, 2002), 151735D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 8, 2002), 167390D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 8, 2002), 127184D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 8, 2002), 80205D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 8, 2002), 79893D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(27, 8, 2002), 201723D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 8, 2002), 114001D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 8, 2002), 188389D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 8, 2002), 162801D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 9, 2002), 200951D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 9, 2002), 129229D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(5, 9, 2002), 183348D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(6, 9, 2002), 216722D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 9, 2002), 128575D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 9, 2002), 224714D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 9, 2002), 144224D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(12, 9, 2002), 195721D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(13, 9, 2002), 160724D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 9, 2002), 65473D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 9, 2002), 141274D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 9, 2002), 115084D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(19, 9, 2002), 242106D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(20, 9, 2002), 130034D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 9, 2002), 95215D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 9, 2002), 229288D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 9, 2002), 163672D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(26, 9, 2002), 193573D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(27, 9, 2002), 170741D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 9, 2002), 199615D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(1, 10, 2002), 170771D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(2, 10, 2002), 138498D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(3, 10, 2002), 154774D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(4, 10, 2002), 287154D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(7, 10, 2002), 111762D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(8, 10, 2002), 172535D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(9, 10, 2002), 148339D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(10, 10, 2002), 178796D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(11, 10, 2002), 153499D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(14, 10, 2002), 4589D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(15, 10, 2002), 172088D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(16, 10, 2002), 151267D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(17, 10, 2002), 222680D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(18, 10, 2002), 127019D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(21, 10, 2002), 118226D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(22, 10, 2002), 183031D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(23, 10, 2002), 221005D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(24, 10, 2002), 121333D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(25, 10, 2002), 138179D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(28, 10, 2002), 162012D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(29, 10, 2002), 237355D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(30, 10, 2002), 161650D)) ;
    volumeDataset.addData(0, createIntervalData(createDate(31, 10, 2002), 207569D)) ;

    return volumeDataset ;
  }

  private static SingleRowDataset createPriceDataset() {
    SingleRowDataset priceDataset = new SingleRowDataset() ;
    priceDataset.addRowKey("Price") ;
    priceDataset.addRowData() ;

    priceDataset.addData(0, createXYData(createDate(2, 1, 2002), 95.564999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 1, 2002), 95.640000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 1, 2002), 95.709999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 1, 2002), 95.930000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 1, 2002), 95.930000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 1, 2002), 95.959999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 1, 2002), 96.055000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 1, 2002), 96.334999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 1, 2002), 96.290000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 1, 2002), 96.275000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 1, 2002), 96.239999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 1, 2002), 96.079999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 1, 2002), 96.144999999999996D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 1, 2002), 96.120000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 1, 2002), 96.015000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 1, 2002), 95.890000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 1, 2002), 95.864999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 1, 2002), 95.879999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 1, 2002), 96.049999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 1, 2002), 96.064999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(31, 1, 2002), 95.909999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 2, 2002), 96.015000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 2, 2002), 96.140000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 2, 2002), 96.194999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 2, 2002), 96.245000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 2, 2002), 96.219999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 2, 2002), 96.280000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 2, 2002), 96.265000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 2, 2002), 96.159999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 2, 2002), 96.120000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 2, 2002), 96.125D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 2, 2002), 96.265000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 2, 2002), 96.290000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 2, 2002), 96.275000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 2, 2002), 96.280000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 2, 2002), 96.305000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 2, 2002), 96.265000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 2, 2002), 96.185000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(27, 2, 2002), 96.305000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 2, 2002), 96.215000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 3, 2002), 96.015000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 3, 2002), 95.969999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 3, 2002), 95.935000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 3, 2002), 95.935000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 3, 2002), 95.704999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 3, 2002), 95.484999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 3, 2002), 95.504999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 3, 2002), 95.540000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 3, 2002), 95.674999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 3, 2002), 95.510000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 3, 2002), 95.5D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 3, 2002), 95.5D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 3, 2002), 95.534999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 3, 2002), 95.420000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 3, 2002), 95.400000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 3, 2002), 95.375D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 3, 2002), 95.349999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 3, 2002), 95.504999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(27, 3, 2002), 95.549999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 3, 2002), 95.484999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 4, 2002), 95.484999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(2, 4, 2002), 95.629999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 4, 2002), 95.734999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 4, 2002), 95.694999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 4, 2002), 95.810000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 4, 2002), 95.810000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 4, 2002), 95.864999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 4, 2002), 95.885000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 4, 2002), 95.900000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 4, 2002), 95.980000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 4, 2002), 96.034999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 4, 2002), 96D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 4, 2002), 96.034999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 4, 2002), 96.084999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 4, 2002), 96.075000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 4, 2002), 96.105000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 4, 2002), 96.075000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 4, 2002), 96.209999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 4, 2002), 96.254999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 4, 2002), 96.310000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 4, 2002), 96.310000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 4, 2002), 96.325000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 5, 2002), 96.344999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(2, 5, 2002), 96.284999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 5, 2002), 96.385000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 5, 2002), 96.379999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 5, 2002), 96.484999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 5, 2002), 96.230000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 5, 2002), 96.310000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 5, 2002), 96.444999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 5, 2002), 96.355000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 5, 2002), 96.180000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 5, 2002), 96.239999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 5, 2002), 96.325000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 5, 2002), 96.200000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 5, 2002), 96.305000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 5, 2002), 96.385000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 5, 2002), 96.444999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 5, 2002), 96.385000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 5, 2002), 96.390000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 5, 2002), 96.390000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 5, 2002), 96.474999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 5, 2002), 96.555000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(31, 5, 2002), 96.5D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 6, 2002), 96.540000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 6, 2002), 96.605000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 6, 2002), 96.579999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 6, 2002), 96.609999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 6, 2002), 96.599999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 6, 2002), 96.614999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 6, 2002), 96.704999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 6, 2002), 96.75D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 6, 2002), 96.829999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 6, 2002), 96.965000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 6, 2002), 96.944999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 6, 2002), 96.989999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 6, 2002), 97.165000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 6, 2002), 97.030000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 6, 2002), 97.144999999999996D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 6, 2002), 97.120000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 6, 2002), 97.174999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 6, 2002), 97.364999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(27, 6, 2002), 97.245000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 6, 2002), 97.245000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 7, 2002), 97.290000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(2, 7, 2002), 97.379999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 7, 2002), 97.379999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 7, 2002), 97.219999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 7, 2002), 97.325000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 7, 2002), 97.454999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 7, 2002), 97.579999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 7, 2002), 97.605000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 7, 2002), 97.689999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 7, 2002), 97.730000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 7, 2002), 97.579999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 7, 2002), 97.640000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 7, 2002), 97.680000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 7, 2002), 97.715000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 7, 2002), 97.814999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 7, 2002), 97.875D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 7, 2002), 97.834999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 7, 2002), 97.924999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 7, 2002), 97.959999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 7, 2002), 97.745000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 7, 2002), 97.709999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(31, 7, 2002), 97.930000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 8, 2002), 98D)) ;
    priceDataset.addData(0, createXYData(createDate(2, 8, 2002), 98.170000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 8, 2002), 98.224999999999994D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 8, 2002), 98.114999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 8, 2002), 98.265000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 8, 2002), 98.180000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 8, 2002), 98.185000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 8, 2002), 98.150000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 8, 2002), 98.290000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 8, 2002), 98.155000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 8, 2002), 98.075000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 8, 2002), 98D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 8, 2002), 98.040000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 8, 2002), 98.135000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 8, 2002), 98.109999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 8, 2002), 98.004999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 8, 2002), 98.055000000000007D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 8, 2002), 98.064999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(27, 8, 2002), 97.980000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 8, 2002), 98.034999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 8, 2002), 98.094999999999999D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 8, 2002), 98.060000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 9, 2002), 98.25D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 9, 2002), 98.245000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(5, 9, 2002), 98.314999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(6, 9, 2002), 98.170000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 9, 2002), 98.079999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 9, 2002), 98.090000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 9, 2002), 98.030000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(12, 9, 2002), 98.105000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(13, 9, 2002), 98.135000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 9, 2002), 98.114999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 9, 2002), 98.125D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 9, 2002), 98.129999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(19, 9, 2002), 98.254999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(20, 9, 2002), 98.254999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 9, 2002), 98.280000000000001D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 9, 2002), 98.310000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 9, 2002), 98.25D)) ;
    priceDataset.addData(0, createXYData(createDate(26, 9, 2002), 98.299999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(27, 9, 2002), 98.409999999999997D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 9, 2002), 98.495000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(1, 10, 2002), 98.439999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(2, 10, 2002), 98.439999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(3, 10, 2002), 98.439999999999998D)) ;
    priceDataset.addData(0, createXYData(createDate(4, 10, 2002), 98.379999999999995D)) ;
    priceDataset.addData(0, createXYData(createDate(7, 10, 2002), 98.385000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(8, 10, 2002), 98.340000000000003D)) ;
    priceDataset.addData(0, createXYData(createDate(9, 10, 2002), 98.420000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(10, 10, 2002), 98.375D)) ;
    priceDataset.addData(0, createXYData(createDate(11, 10, 2002), 98.275000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(14, 10, 2002), 98.275000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(15, 10, 2002), 98.135000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(16, 10, 2002), 98.165000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(17, 10, 2002), 98.170000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(18, 10, 2002), 98.165000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(21, 10, 2002), 98.105000000000004D)) ;
    priceDataset.addData(0, createXYData(createDate(22, 10, 2002), 98.125D)) ;
    priceDataset.addData(0, createXYData(createDate(23, 10, 2002), 98.185000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(24, 10, 2002), 98.245000000000005D)) ;
    priceDataset.addData(0, createXYData(createDate(25, 10, 2002), 98.319999999999993D)) ;
    priceDataset.addData(0, createXYData(createDate(28, 10, 2002), 98.420000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(29, 10, 2002), 98.540000000000006D)) ;
    priceDataset.addData(0, createXYData(createDate(30, 10, 2002), 98.545000000000002D)) ;
    priceDataset.addData(0, createXYData(createDate(31, 10, 2002), 98.560000000000002D)) ;

    return priceDataset ;
  }

  /**
   * Creates a date.
   *
   * @param day  the day.
   * @param month  the month (1 - 12).
   * @param yyyy  the year.
   *
   * @return a date.
   */
  public static synchronized Date createDate(final int day, final int month, final int yyyy) {
    CALENDAR.clear() ;
    CALENDAR.set(yyyy, month - 1, day, 0, 0) ;

    return CALENDAR.getTime() ;
  }

  private static IntervalXYNumberChartData createIntervalData(Date calStart, double value) {
    long start = calStart.getTime() ;

    long end = start + 24 * 60 * 60 * 1000 ;

    return new IntervalXYNumberChartData(start, end, 0, value) ;
  }

  private static XYNumberChartData createXYData(Date calStart, double value) {
    long start = calStart.getTime() ;

    return new XYNumberChartData(start, value) ;
  }

}
