package demo.others.categorycharts;

import java.awt.GridLayout ;
import java.util.ArrayList ;
import java.util.List ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.category.GroupCategoryAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLocation ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.group.NumberGroupChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberGroupChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.AbstractCategoryRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GroupStackedBarChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset1 = createDataset1() ;

  public GroupStackedBarChartPanel1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createGroupStackedBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset1, vertical, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractCategoryRender render = plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberGroupChartDataFormatter(
      "#0.00"), true)) ;
    plot.setCategoryAxis(1, createCategoryAxis2(render)) ;
    plot.setCategoryAxisLocation(1, AxisLocation.TOP_OR_RIGHT) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private CategoryAxis createCategoryAxis2(AbstractCategoryRender render) {
    GroupCategoryAxis categoryAxis = new GroupCategoryAxis(render, null, dataset1) ;
    CategoryAxis subCategoryAxis = new CategoryAxis("category label2", dataset1) ;
    subCategoryAxis.setAxisLineVisible(false) ;
    subCategoryAxis.setTickMarkVisible(false);
    categoryAxis.addSubCategoryAxis(subCategoryAxis) ;

    return categoryAxis ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("123456789011") ;
    dataset.addRowKey("ab\ncd\nef") ;
    dataset.addRowKey("abcde") ;
    dataset.addRowKey("12345678") ;
    dataset.addRowKey("") ;

    int index = 1 ;
    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      for (int j = 1 ; j <= 5 ; j++) {
        if (i == 0 && j % 5 != 0) {
          dataset.addColKey("col key " + j) ;
        } else {
          dataset.addColKey("long long long long col key " + j) ;
        }

        if (i % 2 == 0 && j == 3) {
          dataset.addData(i, null) ;
        } else if (i % 2 == 0) {
          List list = new ArrayList() ;
          for (int m = 0 ; m < 3 ; m++) {
            list.add(new Double((m + 2) * Math.random() * 10)) ;
          }

          dataset.addData(i, new NumberGroupChartData(String.valueOf(index++), list)) ;
        } else {
          List list = new ArrayList() ;
          for (int m = 0 ; m < 3 ; m++) {
            list.add(new Double((m + 2) * Math.random() * 10)) ;
          }

          dataset.addData(i, new NumberGroupChartData(String.valueOf(index++), list)) ;
        }

      }
    }

    return dataset ;
  }

}
