package demo.others.shapes ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Point2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.IShapedChartShape ;
import com.ijchart.xychart.test.SerialTestUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IShapedChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public IShapedChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(2, 3)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final IShapedChartShape shape = new IShapedChartShape(10, 120, 60, 100) ;

//    shape.setRotate(Math.PI / 10) ;
    shape.setBorderStroke(new BasicStroke(1)) ;
    shape.setBorderPaint(Color.RED) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final IShapedChartShape shape = new IShapedChartShape(10, 120, 60, 100) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setRotate( -Math.PI / 20) ;
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    final IShapedChartShape shape = new IShapedChartShape(10, 120, 60, 100) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setRotate(Math.PI / 2) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    final IShapedChartShape shape = new IShapedChartShape(10, 120, 60, 100) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setRotate(Math.PI / 16) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true) ;
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel5() {
    IShapedChartShape shape = new IShapedChartShape(80, 80, 95, 23) ;

    shape.setBorderPaint(Color.RED) ;
    shape.setRotate(Math.PI / 8) ;

    IShapedChartShape clone = null ;
    try {
      clone = (IShapedChartShape) shape.clone() ;
    } catch (CloneNotSupportedException ex) {
    }
    SerialTestUtil.serialObject(clone) ;
    final IShapedChartShape seri = (IShapedChartShape) SerialTestUtil.unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        seri.setSelected(true) ;
        seri.draw((Graphics2D) g) ;

        Point2D p = seri.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + seri.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }
}
