package demo.others.shapes ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Font ;
import java.awt.GradientPaint ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextDirection ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.shape.RectangleTextChartShape ;
import com.ijchart.xychart.test.SerialTestUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RectangleTextChartShapePanel1 extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public RectangleTextChartShapePanel1() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(5, 4)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;
    addPanel6() ;
    addPanel7() ;
    addPanel8() ;
    addPanel12() ;
    addPanel13() ;
    addPanel14() ;
    addPanel15() ;
    addPanel16() ;
    addPanel17() ;

    addPanel18() ;
    addPanel19() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(0, 0, 100, 100), "1234567890abcdefghijklmnopqrstuvwxyz") ;
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel2() {
    String str = "aa1234567890abcdefghijklmnopqrstuvwxyz" ;
    str += str ;
    str += str ;

    final RectangleTextChartShape textShape =
      new RectangleTextChartShape(new Rectangle2D.Double(5, 5, 80, 80), str) ;
    textShape.setBorderStroke(new BasicStroke(10)) ;
    textShape.setRotate(Math.PI / 10) ;
    textShape.setDrawBorder(true) ;
//    textShape.setDrawBorder(false);

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;
        textShape.draw((Graphics2D) g) ;
      }

    } ;

    textShape.setFillPaint(Color.yellow) ;
    textShape.setFillShape(true) ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel3() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(0, 0, 100, 100),
      "012 d a\n345 6789abcdefghijklmnopqrstuvwxyz",
      new Font("SansSerif", Font.BOLD, 25)) ;
    textShape.setDrawBorder(true) ;
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel4() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(0, 0, 100, 100),
      "1234567890abcdefghijklmnopqrstuvwxyz",
      new Font("SansSerif", Font.BOLD, 25)) ;
    textShape.setFillPaint(new GradientPaint(0.0f, 0.0f, Color.blue, 0.0f, 0.0f, new Color(0, 0, 64))) ;
    textShape.setFillShape(true) ;
    textShape.setBorderPaint(Color.red) ;
    textShape.setDrawBorder(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel5() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 100),
      "zz1234567j90abcdefghijklmnopqrstuvjg",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    textShape.setRotate(Math.PI / 30) ;
    textShape.setFillShape(true) ;
    textShape.setFillPaint(Color.yellow) ;
    textShape.setTextPaint(Color.red) ;
    textShape.setDrawBorder(true) ;

    textShape.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    textShape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g2.setPaint(Color.red) ;
        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(120, 120)) ;
    add(panel) ;
  }

  private void addPanel6() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(5, 5, 100, 100),
      "1234567890abcdefghijklmnopqrstuvwxyz",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    textShape.setDrawBorder(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw((Graphics2D) g) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(120, 120)) ;
    add(panel) ;
  }

  private void addPanel7() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 100),
      "1234567890abcdefghijklmnopqrstuvwxyz",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    textShape.setRotate(Math.PI / 30) ;
    textShape.setFillShape(true) ;
    textShape.setFillPaint(Color.yellow) ;
    textShape.setTextPaint(Color.red) ;
    textShape.setDrawBorder(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g2.setPaint(Color.red) ;
        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(120, 120)) ;
    add(panel) ;
  }

  private void addPanel8() {
    final RectangleTextChartShape textShape = new RectangleTextChartShape(
      new Rectangle2D.Double(20, 20, 100, 100),
      "1234567890abcdefghijklmnopqrstuvwxyz",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    textShape.setRotate(Math.PI / 30) ;
    textShape.setFillShape(true) ;
    textShape.setFillPaint(Color.yellow) ;
    textShape.setTextPaint(Color.red) ;
    textShape.setDrawBorder(true) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        g2.setPaint(Color.red) ;
        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    add(panel) ;
  }

  private void addPanel12() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(20, 50, 100, 50), "Left\nabcdgjq1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextHorizontalAlign(HorizontalAlignment.LEFT) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel13() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(20, 50, 100, 50), "Center\n1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel14() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(20, 50, 100, 50), "Right\n1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextHorizontalAlign(HorizontalAlignment.RIGHT) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel15() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(40, 50, 30, 50),
                                  "Top\n12345\n67890\nabcdef",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel16() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(40, 50, 30, 50),
                                  "Center\n12345\n67890\nabcdef",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel17() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(40, 50, 30, 50),
                                  "Bottom\n12345\n67890\nabcdef",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel18() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Left\n1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextHorizontalAlign(HorizontalAlignment.LEFT) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel19() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Center\n1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true);
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }
}
