package demo.others.shapes ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.shape.StatisticalLineChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StatisticalLineChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private String text = "abcd" ;

  private JLabel label ;

  public StatisticalLineChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(3, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    Rectangle2D rect = new Rectangle2D.Double(10, 40, 60, 40) ;
    final StatisticalLineChartShape shape =
      new StatisticalLineChartShape(rect, text, 10, 120, 60, 100,
                                    new Point2D.Double(40, 70),
                                    new Point2D.Double(80, 100)) ;

    shape.setDrawBorder(true) ;
    shape.setBorderStroke(new BasicStroke(1)) ;
    shape.setBorderPaint(Color.RED) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.CYAN) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    Rectangle2D rect = new Rectangle2D.Double(10, 40, 60, 40) ;
    final StatisticalLineChartShape shape = new StatisticalLineChartShape(rect, text, 10, 120, 60,
                                                                          100,
                                                                          new Point2D.Double(40, 70),
                                                                          new Point2D.Double(20, 30)) ;

    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setRotate( -Math.PI / 20) ;
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.CYAN) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    Rectangle2D rect = new Rectangle2D.Double(80, 40, 60, 40) ;
    final StatisticalLineChartShape shape = new StatisticalLineChartShape(rect, text, 80, 120, 60,
                                                                          100,
                                                                          new Point2D.Double(110,
                                                                                             70),
                                                                          new Point2D.Double(20, 30)) ;

    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setRotate(Math.PI / 2) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.CYAN) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    Rectangle2D rect = new Rectangle2D.Double(30, 40, 60, 40) ;
    final StatisticalLineChartShape shape =
      new StatisticalLineChartShape(rect, text, 30, 150, 60,
                                    100, new Point2D.Double(60, 100),
                                    new Point2D.Double(90, 20)) ;

    shape.setDrawBorder(true) ;
    shape.setBorderPaint(Color.RED) ;
    shape.setRotate(Math.PI / 16) ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.setSelected(true);
        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.CYAN) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(150, 150)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

}
