package demo.others.stackareacharts ;

import java.awt.GridLayout ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.XYNumberChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.label.ILabelGenerator ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.AbstractXYRender ;
import com.ijchart.xychart.render.xy.XYStackedBarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedXYBarChartPanel6 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public StackedXYBarChartPanel6() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//   addPanel2() ;
//    addPanel3() ;
//   addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
//         ((XYStackedBarRender) plot.getRender()).setAutoWidth(false) ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setMargin(0.14999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;
    setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setMargin(0.14999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_BOTTOM) ;
    setChartLabelXY(chart) ;
//        ((XYStackedBarRender) plot.getRender()).setAutoWidth(false) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setMargin(0.14999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_RIGHT) ;
    setChartLabelXY(chart) ;
//        ((XYStackedBarRender) plot.getRender()).setAutoWidth(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setMargin(0.14999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_LEFT) ;
    setChartLabelXY(chart) ;
//        ((XYStackedBarRender) plot.getRender()).setAutoWidth(true) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static void setChartLabelXY(IJChart chart) {
    XYPlot plot = (XYPlot) chart.getPlot() ;
    plot.setForegroundAlpha(0.8F) ;
    AbstractXYRender render = plot.getRender() ;
    XYNumberChartDataFormatter format =
      new XYNumberChartDataFormatter("#.#", "#.#",
                                     XYNumberChartDataFormatter.XYNUMBER_FORMATTER_TYPE_Y) ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;

    render.setLabelGenerator(labelGenerator) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    for (int i = 0 ; i < 21 ; i++) {
      dataset.addColKey("Col" + (i + 1)) ;
    }

    dataset.addRowKey("Albatrosses") ;
    dataset.addRowKey("Aces") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1983), 0.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1984), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1985), 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1986), 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1987), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1988), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1989), 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1990), 5D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1991), 5D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1992), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1993), 4D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1994), 3D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1995), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1996), 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1997), 2D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1998), 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(1999), 4D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2000), 6D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2001), 5D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2002), 4D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2003), 2D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1983), 21D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1984), 24D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1985), 32D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1986), 20D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1987), 28D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1988), 17D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1989), 31D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1990), 32D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1991), 29D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1992), 31D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1993), 25D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1994), 44D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1995), 35D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1996), 40D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1997), 32D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1998), 32D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(1999), 30D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2000), 29D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2001), 28D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2002), 39D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2003), 32D)) ;

    return dataset ;
  }

  private static long getYearMills(int year) {
    Date date = new Date(year - 1900, 1, 1, 0, 0, 0) ;
    return date.getTime() ;
  }

}
