package demo.others.xy ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXNumberYBaseChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IntervalXNumberYBaseBar2DChartPanelHour extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public IntervalXNumberYBaseBar2DChartPanelHour() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;
//        setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.5F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.5F)) ;
//
//        AbstractValueAxis valueAxis = plot.getValueAxis() ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(4.0F)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;

    dataset.addRowData() ;
    Calendar[] calArr1 = {createCalendar(1), createCalendar(2),
                         createCalendar(3), createCalendar(4),
                         createCalendar(5), createCalendar(6),
                         createCalendar(7), createCalendar(8)} ;
    double[] valueArr1 = {54.299999999999997D, 20.300000000000001D, 43.399999999999999D, -12D} ;
    for (int i = 0 ; i < calArr1.length / 2 ; i++) {
      dataset.addData(0, createData(calArr1[i * 2], calArr1[i * 2 + 1], valueArr1[i])) ;
    }

    dataset.addRowData() ;
    Calendar[] calArr2 = {createCalendar(2), createCalendar(3),
                         createCalendar(4), createCalendar(5),
                         createCalendar(6), createCalendar(7),
                         createCalendar(8), createCalendar(9)} ;
    double[] valueArr2 = {8D, 16D, 21D, 5D} ;
    for (int i = 0 ; i < calArr2.length / 2 ; i++) {
      dataset.addData(1, createData(calArr2[i * 2], calArr2[i * 2 + 1], valueArr2[i])) ;
    }

    return dataset ;
  }

  private Calendar createCalendar(int hour) {
    Calendar cal = Calendar.getInstance() ;
    cal.set(2010, 1, 10, hour, 0, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    return cal ;
  }

  private static IntervalXNumberYBaseChartData createData(Calendar calStart, Calendar calEnd,
                                                          double value) {
    long start = calStart.getTime().getTime() ;
    long end = calEnd.getTime().getTime() ;

    return new IntervalXNumberYBaseChartData(start, end, value) ;
  }

}
