package demo.piecharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.Rotation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PieChart3DDemo1 extends JPanel {

  public PieChart3DDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPie3DChart("Pie Chart 3D Demo 1", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    plot.setForegroundAlpha(0.5F) ;
    plot.setNoDataMessage("No data to display") ;

    PieRender render = (PieRender) plot.getRender() ;
    render.setStartAngle(290D) ;
    render.setCircular(true) ;
    render.setPieRotation(Rotation.CLOCKWISE) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("Java") ;
    dataset.addColKey("Visual Basic") ;
    dataset.addColKey("C/C++") ;
    dataset.addColKey("PHP") ;
    dataset.addColKey("Perl") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(43.200000000000003D)) ;
    dataset.addData(0, new NumberChartData(10D)) ;
    dataset.addData(0, new NumberChartData(17.5D)) ;
    dataset.addData(0, new NumberChartData(32.5D)) ;
    dataset.addData(0, null) ;

    return dataset ;
  }

}
