package demo.statisticalcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.BoxAndWhiskerValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.BoxAndWhiskerData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BoxAndWhiskerChartDemo1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  public BoxAndWhiskerChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBoxAndWhiskerChart(
      "Box and Whisker Chart Demo 1", "Category", "Value", dataset, vertical, true, true) ;

    CategoryPlot categoryplot = (CategoryPlot) chart.getPlot() ;
    BoxAndWhiskerValueAxis numberaxis = (BoxAndWhiskerValueAxis) categoryplot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Series 0") ;
    dataset.addColKey("Series 1") ;
    dataset.addColKey("Series 2") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      dataset.addRowKey("Category " + i) ;
      for (int j = 0 ; j < 3 ; j++) {
        final double d = 0.0D ;
        final double d1 = 20D ;
        BoxAndWhiskerData data = new BoxAndWhiskerData() ;
        for (int m = 0 ; m < 20 ; m++) {
          double d2 = d + Math.random() * (d1 - d) ;
          data.addValue(new Double(d2)) ;
        }
        dataset.addData(i, data) ;
      }

    }

    return dataset ;
  }
}
