package demo.timeseriescharts;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.MillisecondsToDateFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo1 extends JPanel {

  public TimeSeriesDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Legal & General Unit Trust Prices",
                                                           "Date", "Price Per Unit", dataset,
                                                           ChartOrientation.VERTICAL, true, true,
                                                           true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setDomainCrosshairVisible(true) ;
    xyplot.setValueCrosshairVisible(true) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("MMM-yyyy")) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("L&G European Index Trust") ;
    dataset.addRowKey("L&G UK Index Trust") ;
    dataset.addRowData(2) ;

    dataset.addData(0, createData(2, 2001, 181.80000000000001D)) ;
    dataset.addData(0, createData(3, 2001, 167.30000000000001D)) ;
    dataset.addData(0, createData(4, 2001, 153.80000000000001D)) ;
    dataset.addData(0, createData(5, 2001, 167.59999999999999D)) ;
    dataset.addData(0, createData(6, 2001, 158.80000000000001D)) ;
    dataset.addData(0, createData(7, 2001, 148.30000000000001D)) ;
    dataset.addData(0, createData(8, 2001, 153.90000000000001D)) ;
    dataset.addData(0, createData(9, 2001, 142.69999999999999D)) ;
    dataset.addData(0, createData(10, 2001, 123.2D)) ;
    dataset.addData(0, createData(11, 2001, 131.80000000000001D)) ;
    dataset.addData(0, createData(12, 2001, 139.59999999999999D)) ;
    dataset.addData(0, createData(1, 2002, 142.90000000000001D)) ;
    dataset.addData(0, createData(2, 2002, 138.69999999999999D)) ;
    dataset.addData(0, createData(3, 2002, 137.30000000000001D)) ;
    dataset.addData(0, createData(4, 2002, 143.90000000000001D)) ;
    dataset.addData(0, createData(5, 2002, 139.80000000000001D)) ;
    dataset.addData(0, createData(6, 2002, 137D)) ;
    dataset.addData(0, createData(7, 2002, 132.80000000000001D)) ;
    dataset.addData(0, createData(8, 2002, 110.3D)) ;
    dataset.addData(0, createData(9, 2002, 110.5D)) ;
    dataset.addData(0, createData(10, 2002, 94.109999999999999D)) ;
    dataset.addData(0, createData(11, 2002, 102.5D)) ;
    dataset.addData(0, createData(12, 2002, 112.3D)) ;
    dataset.addData(0, createData(1, 2003, 104D)) ;
    dataset.addData(0, createData(2, 2003, 98.530000000000001D)) ;
    dataset.addData(0, createData(3, 2003, 97.150000000000006D)) ;
    dataset.addData(0, createData(4, 2003, 94.900000000000006D)) ;
    dataset.addData(0, createData(5, 2003, 107.8D)) ;
    dataset.addData(0, createData(6, 2003, 113.7D)) ;
    dataset.addData(0, createData(7, 2003, 112.5D)) ;
    dataset.addData(0, createData(8, 2003, 118.59999999999999D)) ;
    dataset.addData(0, createData(9, 2003, 123.8D)) ;
    dataset.addData(0, createData(10, 2003, 117.2D)) ;
    dataset.addData(0, createData(11, 2003, 123D)) ;
    dataset.addData(0, createData(12, 2003, 127D)) ;
    dataset.addData(0, createData(1, 2004, 132.69999999999999D)) ;
    dataset.addData(0, createData(2, 2004, 132.40000000000001D)) ;
    dataset.addData(0, createData(3, 2004, 131.69999999999999D)) ;
    dataset.addData(0, createData(4, 2004, 128D)) ;
    dataset.addData(0, createData(5, 2004, 131.80000000000001D)) ;
    dataset.addData(0, createData(6, 2004, 127.40000000000001D)) ;
    dataset.addData(0, createData(7, 2004, 133.5D)) ;
    dataset.addData(0, createData(8, 2004, 126D)) ;
    dataset.addData(0, createData(9, 2004, 129.5D)) ;
    dataset.addData(0, createData(10, 2004, 135.30000000000001D)) ;
    dataset.addData(0, createData(11, 2004, 138D)) ;
    dataset.addData(0, createData(12, 2004, 141.30000000000001D)) ;
    dataset.addData(0, createData(1, 2005, 148.80000000000001D)) ;
    dataset.addData(0, createData(2, 2005, 147.09999999999999D)) ;
    dataset.addData(0, createData(3, 2005, 150.69999999999999D)) ;
    dataset.addData(0, createData(4, 2005, 150D)) ;
    dataset.addData(0, createData(5, 2005, 145.69999999999999D)) ;
    dataset.addData(0, createData(6, 2005, 152D)) ;
    dataset.addData(0, createData(7, 2005, 157.19999999999999D)) ;
    dataset.addData(0, createData(8, 2005, 167D)) ;
    dataset.addData(0, createData(9, 2005, 165D)) ;
    dataset.addData(0, createData(10, 2005, 171.59999999999999D)) ;
    dataset.addData(0, createData(11, 2005, 166.19999999999999D)) ;
    dataset.addData(0, createData(12, 2005, 174.30000000000001D)) ;
    dataset.addData(0, createData(1, 2006, 183.80000000000001D)) ;
    dataset.addData(0, createData(2, 2006, 187D)) ;
    dataset.addData(0, createData(3, 2006, 191.30000000000001D)) ;
    dataset.addData(0, createData(4, 2006, 202.5D)) ;
    dataset.addData(0, createData(5, 2006, 200.59999999999999D)) ;
    dataset.addData(0, createData(6, 2006, 187.30000000000001D)) ;
    dataset.addData(0, createData(7, 2006, 192.19999999999999D)) ;
    dataset.addData(0, createData(8, 2006, 190.80000000000001D)) ;
    dataset.addData(0, createData(9, 2006, 194.69999999999999D)) ;
    dataset.addData(0, createData(10, 2006, 201.30000000000001D)) ;
    dataset.addData(0, createData(11, 2006, 205.09999999999999D)) ;
    dataset.addData(0, createData(12, 2006, 206.69999999999999D)) ;
    dataset.addData(0, createData(1, 2007, 216.80000000000001D)) ;
    dataset.addData(0, createData(2, 2007, 218D)) ;
    dataset.addData(0, createData(3, 2007, 215.40000000000001D)) ;
    dataset.addData(0, createData(4, 2007, 223D)) ;
    dataset.addData(0, createData(5, 2007, 235.09999999999999D)) ;
    dataset.addData(0, createData(6, 2007, 242D)) ;
    dataset.addData(0, createData(7, 2007, 237.80000000000001D)) ;

    dataset.addData(1, createData(2, 2001, 129.59999999999999D)) ;
    dataset.addData(1, createData(3, 2001, 123.2D)) ;
    dataset.addData(1, createData(4, 2001, 117.2D)) ;
    dataset.addData(1, createData(5, 2001, 124.09999999999999D)) ;
    dataset.addData(1, createData(6, 2001, 122.59999999999999D)) ;
    dataset.addData(1, createData(7, 2001, 119.2D)) ;
    dataset.addData(1, createData(8, 2001, 116.5D)) ;
    dataset.addData(1, createData(9, 2001, 112.7D)) ;
    dataset.addData(1, createData(10, 2001, 101.5D)) ;
    dataset.addData(1, createData(11, 2001, 106.09999999999999D)) ;
    dataset.addData(1, createData(12, 2001, 110.3D)) ;
    dataset.addData(1, createData(1, 2002, 111.7D)) ;
    dataset.addData(1, createData(2, 2002, 111D)) ;
    dataset.addData(1, createData(3, 2002, 109.59999999999999D)) ;
    dataset.addData(1, createData(4, 2002, 113.2D)) ;
    dataset.addData(1, createData(5, 2002, 111.59999999999999D)) ;
    dataset.addData(1, createData(6, 2002, 108.8D)) ;
    dataset.addData(1, createData(7, 2002, 101.59999999999999D)) ;
    dataset.addData(1, createData(8, 2002, 90.950000000000003D)) ;
    dataset.addData(1, createData(9, 2002, 91.019999999999996D)) ;
    dataset.addData(1, createData(10, 2002, 82.370000000000005D)) ;
    dataset.addData(1, createData(11, 2002, 86.319999999999993D)) ;
    dataset.addData(1, createData(12, 2002, 91D)) ;
    dataset.addData(1, createData(1, 2003, 86D)) ;
    dataset.addData(1, createData(2, 2003, 80.040000000000006D)) ;
    dataset.addData(1, createData(3, 2003, 80.400000000000006D)) ;
    dataset.addData(1, createData(4, 2003, 80.280000000000001D)) ;
    dataset.addData(1, createData(5, 2003, 86.420000000000002D)) ;
    dataset.addData(1, createData(6, 2003, 91.400000000000006D)) ;
    dataset.addData(1, createData(7, 2003, 90.519999999999996D)) ;
    dataset.addData(1, createData(8, 2003, 93.109999999999999D)) ;
    dataset.addData(1, createData(9, 2003, 96.799999999999997D)) ;
    dataset.addData(1, createData(10, 2003, 94.780000000000001D)) ;
    dataset.addData(1, createData(11, 2003, 99.560000000000002D)) ;
    dataset.addData(1, createData(12, 2003, 100.8D)) ;
    dataset.addData(1, createData(1, 2004, 103.40000000000001D)) ;
    dataset.addData(1, createData(2, 2004, 102.09999999999999D)) ;
    dataset.addData(1, createData(3, 2004, 105.3D)) ;
    dataset.addData(1, createData(4, 2004, 103.7D)) ;
    dataset.addData(1, createData(5, 2004, 105.2D)) ;
    dataset.addData(1, createData(6, 2004, 103.7D)) ;
    dataset.addData(1, createData(7, 2004, 105.7D)) ;
    dataset.addData(1, createData(8, 2004, 103.59999999999999D)) ;
    dataset.addData(1, createData(9, 2004, 106.09999999999999D)) ;
    dataset.addData(1, createData(10, 2004, 109.3D)) ;
    dataset.addData(1, createData(11, 2004, 110.3D)) ;
    dataset.addData(1, createData(12, 2004, 112.59999999999999D)) ;
    dataset.addData(1, createData(1, 2005, 116D)) ;
    dataset.addData(1, createData(2, 2005, 117.3D)) ;
    dataset.addData(1, createData(3, 2005, 120.09999999999999D)) ;
    dataset.addData(1, createData(4, 2005, 119.3D)) ;
    dataset.addData(1, createData(5, 2005, 116.2D)) ;
    dataset.addData(1, createData(6, 2005, 120.8D)) ;
    dataset.addData(1, createData(7, 2005, 125.2D)) ;
    dataset.addData(1, createData(8, 2005, 127.7D)) ;
    dataset.addData(1, createData(9, 2005, 130.80000000000001D)) ;
    dataset.addData(1, createData(10, 2005, 131D)) ;
    dataset.addData(1, createData(11, 2005, 135.30000000000001D)) ;
    dataset.addData(1, createData(12, 2005, 141.19999999999999D)) ;
    dataset.addData(1, createData(1, 2006, 144.69999999999999D)) ;
    dataset.addData(1, createData(2, 2006, 146.40000000000001D)) ;
    dataset.addData(1, createData(3, 2006, 151.90000000000001D)) ;
    dataset.addData(1, createData(4, 2006, 153.5D)) ;
    dataset.addData(1, createData(5, 2006, 144.5D)) ;
    dataset.addData(1, createData(6, 2006, 150.09999999999999D)) ;
    dataset.addData(1, createData(7, 2006, 148.69999999999999D)) ;
    dataset.addData(1, createData(8, 2006, 150.09999999999999D)) ;
    dataset.addData(1, createData(9, 2006, 151.59999999999999D)) ;
    dataset.addData(1, createData(10, 2006, 153.40000000000001D)) ;
    dataset.addData(1, createData(11, 2006, 158.30000000000001D)) ;
    dataset.addData(1, createData(12, 2006, 157.59999999999999D)) ;
    dataset.addData(1, createData(1, 2007, 163.90000000000001D)) ;
    dataset.addData(1, createData(2, 2007, 163.80000000000001D)) ;
    dataset.addData(1, createData(3, 2007, 162D)) ;
    dataset.addData(1, createData(4, 2007, 167.09999999999999D)) ;
    dataset.addData(1, createData(5, 2007, 170D)) ;
    dataset.addData(1, createData(6, 2007, 175.69999999999999D)) ;
    dataset.addData(1, createData(7, 2007, 171.90000000000001D)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month), value) ;
  }

}
