package com.ijchart.xychart.axis ;

import java.awt.Graphics2D ;
import java.awt.geom.Rectangle2D ;

import com.ijchart.xychart.chartinfo.AxisShapeCollection ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڻͼеXYĽӿ,͵XYᶼҪʵִ˽ӿ.</zh>
 * <en>Interface for draw axis on chart,all types of axis should implement this interface.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IAxis {

  /**
   * <zh>ͼplot(plotArea)XY.ͼеͼδshapeCollection.</zh>
   * <en>Draw the X-axis or Y-axis on plot area(plotArea).All axis shape is stored in
   * shapeCollection.</en>
   *
   * @param g2 Graphics2D <zh>ͼ豸(ӡĻ) (Ϊnull).</zh>
   * <en>The graphics device (null not permitted).</en>
   * @param plotArea Rectangle2D <zh>ͼplot.</zh>
   * <en>The area within which the plot should be drawn.</en>
   * @param axisArea Rectangle2D <zh>ʣĿհ.</zh>
   * <en>The empty chart area.</en>
   * @param edge RectangleEdge <zh>λ.</zh>
   * <en>The axis position.</en>
   * @param shapeCollection AxisShapeCollection <zh>ͼμ.</zh>
   * <en>Collects information about the axis (null permitted).</en>
   * @param alignEdge boolean <zh>־ʵʻС,ǷԶ߽.</zh>
   * <en>Controls whether or not translate shapes when the draw area less than the axis area.</en>
   *
   * @return double <zh>ʵʻƵĿȻ߶.</zh>
   * <en>Drawing the actual coordinates axis width or height.</en>
   */
  double draw(Graphics2D g2, Rectangle2D plotArea, Rectangle2D axisArea,
              RectangleEdge edge, AxisShapeCollection shapeCollection, boolean alignEdge) ;

  /**
   * <zh>ҪĿȻ߶.</zh>
   * <en>Calculation the width or height of painting coordinate axis.</en>
   *
   * @param g2 Graphics2D <zh>ͼ豸(ӡĻ) (Ϊnull).</zh>
   * <en>The graphics device (null not permitted).</en>
   * @param plotArea Rectangle2D <zh>ͼplot.</zh>
   * <en>The area within which the plot should be drawn.</en>
   * @param maxAxisArea Rectangle2D <zh>,϶СplotArea.</zh>
   * <en>The maximum area within which the axis should be drawn.</en>
   * @param edge RectangleEdge <zh>λ.</zh>
   * <en>The axis position.</en>
   *
   * @return double <zh>Ȼ߶.</zh>
   * <en>The width or height.</en>
   */
  double calculateAxisSpace(Graphics2D g2, Rectangle2D plotArea,
                            Rectangle2D maxAxisArea, RectangleEdge edge) ;

  /**
   * <zh>ع̶ƿȻ߶.</zh>
   * <en>Returns the fixed axis space.</en>
   *
   * @return double <zh>̶ (Ϊnull).</zh>
   * <en>The fixed axis space (maybe null).</en>
   */
  double getFixedAxisSpace() ;

}
