package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼĻƷ(ˮƽֱ).</zh>
 * <en>Used to indicate the orientation (horizontal or vertical) of a 2D Chart.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class ChartOrientation implements Serializable {

  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization</en>
   */
  private static final long serialVersionUID = -2508771828190337782L ;

  /**
   * <zh>ˮƽ.</zh>
   * <en>The horizontal chart.</en>
   */
  public static final ChartOrientation HORIZONTAL = new ChartOrientation(
    "ChartOrientation.HORIZONTAL") ;

  /**
   * <zh>ֱ.</zh>
   * <en>The vertical chart.</en>
   */
  public static final ChartOrientation VERTICAL = new ChartOrientation("ChartOrientation.VERTICAL") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private ChartOrientation(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof ChartOrientation)) {
      return false ;
    }

    ChartOrientation that = (ChartOrientation) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return name.hashCode() ;
  }

}
