package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.EqualsUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼ(Grantt)ͼλƷʽ,ƽлֱ.</zh>
 * <en>An enumeration of the grantt draw type (PARALLELA,VERTICAL).</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class GranttDrawType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 7825296461261634957L ;

  /**
   * <zh>.</zh>
   * <en>Top alignment.</en>
   */
  public static final GranttDrawType PARALLELA = new GranttDrawType("GranttDrawType.PARALLELA") ;

  /**
   * <zh>׶.</zh>
   * <en>Bottom alignment.</en>
   */
  public static final GranttDrawType VERTICAL = new GranttDrawType("GranttDrawType.VERTICAL") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private GranttDrawType(final String name) {
    this.name = name ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ,ȷtrue,򷵻false.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull)</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(final Object obj) {

    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof GranttDrawType)) {
      return false ;
    }

    GranttDrawType that = (GranttDrawType) obj ;
    if (!EqualsUtil.equals(this.name, that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hashcodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

}
