package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.EqualsUtil ;
import com.ijchart.xychart.util.HashcodeUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼϵXYֵ.</zh>
 * <en>Describe the type of XY number value axis.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class XYValueAxisType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -6507977673177075275L ;

  /**
   * <zh>X͵XYֵ.</zh>
   * <en>The X type of XY axis.</en>
   */
  public static final XYValueAxisType XY_VALUE_AXIS_X = new XYValueAxisType(
    "XYValueAxisType.X-AXIS") ;

  /**
   * <zh>y͵XYֵ.</zh>
   * <en>The y type of XY axis.</en>
   */
  public static final XYValueAxisType XY_VALUE_AXIS_Y = new XYValueAxisType(
    "XYValueAxisType.Y-AXIS") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private XYValueAxisType(String name) {
    this.name = name ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof XYValueAxisType)) {
      return false ;
    }

    XYValueAxisType that = (XYValueAxisType) obj ;
    return EqualsUtil.equals(this.name, that.name) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[name=" + this.name + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return HashcodeUtil.hashCode(this.name) ;
  }

}
