package com.ijchart.xychart.dataset ;

import com.ijchart.xychart.listener.IDatasetChangeListener ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>
 * ʾݼĻ.
 * <P>
 * еݼҪʵֱӿеķ,ͨ¼{@link com.ijchart.xychart.event.DatasetChangeEvent}
 * ֪ͨݼļݵı仯.</zh>
 * <en>The base interface for data sets.
 * <P>
 * All datasets are required to support the {@link com.ijchart.xychart.event.DatasetChangeEvent}
 * mechanism by allowing listeners to register and receive notification of any
 * changes to the dataset.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IDataset {
  /**
   * <zh>עݼ仯ļ߶.</zh>
   * <en>Registers an object for notification of changes to the dataset.</en>
   *
   * @param listener <zh>עļ.</zh>
   * <en>the object to register.</en>
   */
  void addChangeListener(IDatasetChangeListener listener) ;

  /**
   * <zh>ɾעݼ仯߶</zh>
   * <en>Deregisters an object for notification of changes to the dataset.</en>
   *
   * @param listener <zh>Ҫɾļ߶</zh>
   * <en>the object to deregister.</en>
   */
  void removeChangeListener(IDatasetChangeListener listener) ;

  /**
   * <zh>еݼ仯߶</zh>
   * <en>Deregisters all object for notification of changes to the dataset.</en>
   */
  void removeAllChangeListener() ;

  /**
   * <zh>ݼͨݼķıֵ,ͨ˷֪ͨݼı.</zh>
   * <en>If the data object of dataset changed by method out of dataset,set dataset changed by
   * this method.</en>
   */
  void forceDataSetChanged() ;

  /**
   * <zh>жеֵǷc.</zh>
   * <en>Test whether or not all data is Class c in this dataset.</en>
   *
   * @param c Class <zh>Ҫжϵclass.</zh>
   * <en>A class.</en>
   * @return boolean <zh>ֵctrue,򷵻false.</zh>
   * <en>Returns true if all data equals Class c in this dataset,false otherwise.</en>
   */
  boolean isThisDataType(Class c) ;
}
