package com.ijchart.xychart.render.paint ;

import java.awt.Paint ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ĳֵȡpaintĽӿ.</zh>
 * <en>An interface for get paint object by a specified value.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IPaintScale {
  /**
   * <zh>ȱʡСֵ߽.</zh>
   * <en>The default lower bound.</en>
   */
  double DEFAULT_LOWER_BOUND = 0.0D ;

  /**
   * <zh>ȱʡֵ߽.</zh>
   * <en>The default upper bound.</en>
   */
  double DEFAULT_UPPER_BOUND = 1.0 ;

  /**
   * <zh>Сֵ߽.</zh>
   * <en>The lower bound.</en>
   *
   * @return double <zh>Сֵ߽.</zh>
   * <en>The lower bound.</en>
   */
  double getLowerBound() ;

  /**
   * <zh>ֵ߽.</zh>
   * <en>The upper bound.</en>
   *
   * @return double <zh>ֵ߽.</zh>
   * <en>The upper bound.</en>
   */
  double getUpperBound() ;

  /**
   * <zh>ĳֵӦpaint.</zh>
   * <en>Returns a Paint instance for the specified value.</en>
   *
   * @param value double <zh>ֵ.</zh>
   * <en>The value.</en>
   *
   * @return Paint <zh>paint (Ϊnull).</zh>
   * <en>The paint object (never null).</en>
   */
  Paint getPaint(double value) ;

}
