package com.ijchart.xychart.render.util ;

import java.util.ArrayList ;
import java.util.Collections ;
import java.util.List ;

import com.ijchart.xychart.shape.IChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>3Dͼ,Ϊ˳Ĳͬ,пͼʾȷ,Ҫλ.</zh>
 * <en>A util class for sort 3d shape.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class Shape3DSortUtil {
  private List shapes ;

  /**
   * <zh>.</zh>
   * <en>A constructor.</en>
   */
  public Shape3DSortUtil() {
    this.shapes = new ArrayList() ;
  }

  /**
   * <zh>һͼ.</zh>
   * <en>Add a shape.</en>
   *
   * @param position double <zh>λ.</zh>
   * <en>The shape position.</en>
   * @param shape IChartShape <zh>ͼζ (Ϊnull).</zh>
   * <en>A shape (null permitted).</en>
   */
  public void addShape(double position, IChartShape shape) {
    this.shapes.add(new ShapeBean(position, shape)) ;
  }

  /**
   * <zh>ɾеͼ.</zh>
   * <en>Clear all shapes.</en>
   */
  public void clearShapes() {
    this.shapes.clear() ;
  }

  /**
   * <zh>еͼν.</zh>
   * <en>Sort all shapes.</en>
   */
  public void sort() {
    Collections.sort(this.shapes) ;
  }

  /**
   * <zh>еͼ.</zh>
   * <en>Returns all shapes.</en>
   *
   * @return List <zh>ͼμ (Ϊnull).</zh>
   * <en>The shapes collection.</en>
   */
  public List getAllShapes() {
    List list = new ArrayList() ;
    for (int i = 0 ; i < this.shapes.size() ; i++) {
      ShapeBean bean = (ShapeBean)this.shapes.get(i) ;
      list.add(bean.shape) ;
    }

    return list ;
  }

  private class ShapeBean implements Comparable {
    private double position ;

    private IChartShape shape ;

    ShapeBean(double pos, IChartShape s) {
      this.position = pos ;
      this.shape = s ;
    }

    public int compareTo(Object obj) {
      if (obj == null) {
        return -1 ;
      }

      ShapeBean that = (ShapeBean) obj ;
      double diff = this.position - that.position ;
      return (diff < 0) ? -1 : ((diff == 0) ? 0 : 1) ;
    }

  }
}
